// Generated by CoffeeScript 1.7.1
(function() {
  var CoffeeScript, cli, cliJSON, compile, dir, encoding, extension, files, fs, md5, stdin, wrench;

  fs = require("fs");

  stdin = require("stdin");

  compile = require('../dist/compiler');

  wrench = require("wrench");

  CoffeeScript = require("coffee-script");

  md5 = require('md5');

  cli = require("commander").version(require('../package.json').version).option("-a, --ast", "Output AST").option("-d, --directory [directory]", "Compile all .jadelet files in the given directory").option("--encoding [encoding]", "Encoding of files being read from --directory (default 'utf-8')").option("-e, --exports [name]", "Export compiled template as (default 'module.exports'").option("--extension [extension]", "Extension to compile").option("-r, --runtime [provider]", "Runtime provider").parse(process.argv);

  encoding = cli.encoding || "utf-8";

  cliJSON = JSON.stringify(cli);

  if (cli.extension) {
    extension = new RegExp("\\." + cli.extension + "$");
  } else {
    extension = /\.jade(let)?$/;
  }

  if ((dir = cli.directory)) {
    dir = dir.replace(/\/*$/, "/");
    files = wrench.readdirSyncRecursive(dir);
    files.forEach(function(path) {
      var basePath, currMD5, exports, inPath, input, md5Path, outPath, prevMD5, program;
      inPath = "" + dir + path;
      if (fs.lstatSync(inPath).isFile()) {
        if (inPath.match(extension)) {
          basePath = inPath.replace(extension, "");
          outPath = "" + basePath + ".js";
          md5Path = "" + basePath + ".md5";
          if (fs.existsSync(outPath) && fs.existsSync(md5Path)) {
            prevMD5 = fs.readFileSync(md5Path, {
              encoding: encoding
            });
          }
          input = fs.readFileSync(inPath, {
            encoding: encoding
          });
          currMD5 = md5(input + cliJSON);
          if (currMD5 !== prevMD5) {
            console.log("Compiling " + inPath + " to " + outPath);
            if (cli.exports) {
              exports = cli.exports.replace("$file", basePath);
            }
            program = compile(input, {
              runtime: cli.runtime,
              exports: exports,
              compiler: CoffeeScript
            });
            fs.writeFileSync(outPath, program);
            return fs.writeFileSync(md5Path, currMD5);
          } else {
            return console.log("Skipping " + inPath + " (no changes)");
          }
        }
      }
    });
  } else {
    stdin(function(input) {
      if (cli.ast) {
        process.stdout.write(JSON.stringify(ast));
      } else {
        return process.stdout.write(compile(input, {
          mode: cli.mode,
          runtime: cli.runtime,
          exports: cli.exports,
          compiler: CoffeeScript
        }));
      }
    });
  }

}).call(this);
