// Generated by CoffeeScript 1.7.1
(function() {
  var ROOT_NAME, compile, indentText, parser, util;

  parser = require("./parser/main");

  module.exports = function(input, options) {
    if (options == null) {
      options = {};
    }
    if (typeof input === "string") {
      input = parser.parse(input);
    }
    return compile(input, options);
  };

  indentText = function(text, indent) {
    if (indent == null) {
      indent = "  ";
    }
    return indent + text.replace(/\n/g, "\n" + indent);
  };

  ROOT_NAME = "__root";

  util = {
    indent: indentText,
    element: function(tag, attributes, contents) {
      var lines;
      if (attributes == null) {
        attributes = [];
      }
      if (contents == null) {
        contents = [];
      }
      return lines = ["" + ROOT_NAME + ".buffer " + ROOT_NAME + ".element " + (JSON.stringify(tag)) + ", this, {" + (attributes.join('\n')) + "}, (" + ROOT_NAME + ") ->", indentText(contents.join("\n")), "  return"];
    },
    buffer: function(value) {
      return ["" + ROOT_NAME + ".buffer " + value];
    },
    attributes: function(node) {
      var attributeLines, attributes, classes, id, ids, specialAttributes, styles;
      id = node.id, classes = node.classes, attributes = node.attributes;
      if (id) {
        ids = [JSON.stringify(id)];
      } else {
        ids = [];
      }
      classes = (classes || []).map(JSON.stringify);
      styles = [];
      if (attributes) {
        attributes = attributes.filter(function(_arg) {
          var name, value;
          name = _arg.name, value = _arg.value;
          if (name === "class") {
            classes.push(value);
          } else if (name === "id") {
            ids.push(value);
          } else if (name === "style") {
            styles.push(value);
          } else {
            return true;
          }
        });
      } else {
        attributes = [];
      }
      specialAttributes = [];
      if (ids.length) {
        specialAttributes.push("id: [" + (ids.join(', ')) + "]");
      }
      if (classes.length) {
        specialAttributes.push("class: [" + (classes.join(', ')) + "]");
      }
      if (styles.length) {
        specialAttributes.push("style: [" + (styles.join(', ')) + "]");
      }
      attributeLines = attributes.map(function(_arg) {
        var name, value;
        name = _arg.name, value = _arg.value;
        name = JSON.stringify(name);
        return "" + name + ": " + value;
      });
      return specialAttributes.concat(attributeLines);
    },
    render: function(node) {
      if (node.tag) {
        return this.tag(node);
      } else {
        return this.contents(node);
      }
    },
    contents: function(node) {
      var bufferedCode, childContent, children, contents, indent, text, unbufferedCode;
      children = node.children, bufferedCode = node.bufferedCode, unbufferedCode = node.unbufferedCode, text = node.text;
      if (unbufferedCode) {
        indent = true;
        contents = [unbufferedCode];
      } else if (bufferedCode) {
        contents = this.buffer(bufferedCode);
      } else if (text) {
        contents = this.buffer(JSON.stringify(text));
      } else if (node.tag) {
        contents = [];
      } else if (node.comment) {
        return [];
      } else {
        contents = [];
        console.warn("No content for node:", node);
      }
      if (children) {
        childContent = this.renderNodes(children);
        if (indent) {
          childContent = this.indent(childContent.join("\n"));
        }
        contents = contents.concat(childContent);
      }
      return contents;
    },
    renderNodes: function(nodes) {
      return [].concat.apply([], nodes.map(this.render, this));
    },
    tag: function(node) {
      var tag;
      tag = node.tag;
      return this.element(tag, this.attributes(node), this.contents(node));
    }
  };

  compile = function(parseTree, _arg) {
    var compiler, exports, items, options, program, programSource, runtime, source, _ref;
    _ref = _arg != null ? _arg : {}, compiler = _ref.compiler, runtime = _ref.runtime, exports = _ref.exports;
    if (runtime == null) {
      runtime = "require" + "(\"jadelet\")";
    }
    if (exports == null) {
      exports = "module.exports";
    }
    items = util.renderNodes(parseTree);
    if (exports) {
      exports = "" + exports + " = ";
    } else {
      exports = "";
    }
    source = "" + exports + "(data) ->\n  \"use strict\"\n  (->\n    " + ROOT_NAME + " = " + runtime + "(this)\n" + (util.indent(items.join("\n"), "    ")) + "\n    return " + ROOT_NAME + ".root\n  ).call(data)";
    options = {
      bare: true
    };
    programSource = source;
    program = compiler.compile(programSource, options);
    return program;
  };

}).call(this);
