// Generated by CoffeeScript 1.7.1
(function() {
  var CoffeeScript, compile, compileRaw, fs, isJadelet, through;

  CoffeeScript = require("coffee-script");

  compile = require("jadelet/dist/main").compile;

  fs = require("fs");

  compileRaw = function(raw) {
    return compile(raw, {
      compiler: CoffeeScript,
      exports: "module.exports",
      runtime: "require('jadelet')"
    });
  };

  require.extensions[".jadelet"] = function(module, filename) {
    var raw, src;
    raw = fs.readFileSync(filename, 'utf8');
    src = compileRaw(raw);
    return module._compile(src, filename);
  };

  through = require("through2");

  isJadelet = function(filename) {
    return filename.match(/\.jadelet$/) || filename.match(/\.jade$/);
  };

  module.exports = function(filename, options) {
    var chunks, flush, transform;
    if (options == null) {
      options = {};
    }
    if (!isJadelet(filename)) {
      return through();
    }
    chunks = [];
    transform = function(chunk, encoding, callback) {
      chunks.push(chunk);
      return callback();
    };
    flush = function(callback) {
      var error, raw, source, stream;
      stream = this;
      raw = Buffer.concat(chunks).toString();
      try {
        source = compileRaw(raw);
        stream.push(source);
        return callback(null);
      } catch (_error) {
        error = _error;
        return callback(error);
      }
    };
    return through(transform, flush);
  };

}).call(this);
